use config::Config;
use std::io::Write;
use std::process::{ChildStdin, Command, Stdio};

pub struct Bar {
    stdin: ChildStdin
}

impl Bar {
    pub fn new(top: bool, cfg: &Config) -> Bar {
        let val = cfg.lookup("bar.fonts").unwrap();
        let fonts = val.as_slice().unwrap();
        let fonts = fonts.iter().flat_map(|elem| elem.as_str());

        let mut bar = Command::new("lemonbar");
        bar.stdin(Stdio::piped());

        if !top {
            bar.arg("-b");
        }

        for font in fonts {
            bar.arg("-f");
            bar.arg(font);
        }

        let child = bar.spawn()
            .ok()
            .expect("Failed to start lemonbar");

        Bar { stdin: child.stdin.unwrap() }
    }

    pub fn send(&mut self, text: &str) {
        writeln!(&mut self.stdin, "{}", text).ok();
    }
}
