use std::sync::mpsc::{Sender};

pub type Channel = Sender<Message>;

#[derive(Debug)]
pub struct Message {
    pub kind: String,
    pub text: String
}

pub fn send(tx: &Channel, kind: &str, text: &str) {
    tx.send(Message {
        kind: kind.to_string(),
        text: text.to_string()
    })
    .ok()
    .expect(&format!("Failed to send message: [{}] {}", kind, text))
}
